using System.Collections.Generic;
using Discord;
using System;
using spike.Data.PersistentData;

namespace template.Embed
{
    public class EmbedFactory
    {
        public static Discord.Embed MakeListEmbed(string type, List<Move> input, int page = 1, ulong serverID = 0)
        {

            EmbedBuilder builder = new EmbedBuilder();
            builder.WithTitle("List of " + type + "s.");
            int ItemsPerPage = 30;
            string items1 = "";
            string items2 = "";
            string items3 = "";

            if (page < 1)
                page = 1;
            if (page > Math.Ceiling((float)input.Count / (float)ItemsPerPage))
                page = (input.Count / ItemsPerPage);

            int i = (page - 1) * ItemsPerPage;
            for (i = (page - 1) * ItemsPerPage; i < page * ItemsPerPage && i < input.Count; i++)
            {
                items1 += "` `" + input[i].longName + "\n";
                items2 += "`" + input[i].keyword.ToLower() + "`\n";
                items3 += "` `" + input[i].rollDesc + "\n";
            }
            builder.AddField("Move", items1, true);
            builder.AddField("Keyword", items2, true);
            builder.AddField("Roll", items3, true);
            if (input.Count > ItemsPerPage)
            {
                builder.WithDescription("Displaying page " + page + " of " + Math.Ceiling((float)input.Count / (float)ItemsPerPage) + "\nTo display another page type `!move list player #` where *#* is a number or click the ⬅️ or ➡️ reactions underneath.");
            }
            builder.WithColor(150, 140, 106);
            return builder.Build();
        }
    }
}